package test;

import junit.framework.*;
import java.awt.*;
import gve.calc.*;
import gve.calc.formula.*;
import gve.calc.logic.*;

public class ProofTest extends GuiTest {
	private String prfName;
	private int uptoLine;

	public ProofTest(String name,String prfName,int uptoLine) {
		super(name);
		this.prfName = prfName;
		this.uptoLine = uptoLine;
	}

	public ProofTest(String name,String prfName) {
		this(name,prfName,-1);
	}

	public static Test suite() {
		TestSuite suite = new TestSuite();
		suite.addTest(new ProofTest("testProof","propctest"));
		suite.addTest(new ProofTest("testProof","propcctest",29));
		
		suite.addTest(new ProofTest("testProof","A"));
		suite.addTest(new ProofTest("testProof","C"));
		suite.addTest(new ProofTest("testProof","C1"));
		suite.addTest(new ProofTest("testProof","C2"));
		suite.addTest(new ProofTest("testProof","R"));
		suite.addTest(new ProofTest("testProof","X"));

		suite.addTest(new ProofTest("testProof","bewijs1"));
		suite.addTest(new ProofTest("testProof","bewijs2"));
		suite.addTest(new ProofTest("testProof","bewijs3"));

		suite.addTest(new ProofTest("testProof","ZeBe"));
		suite.addTest(new ProofTest("testProof","ZeOn"));
		suite.addTest(new ProofTest("testProof","NN1"));
		suite.addTest(new ProofTest("testProof","NN2"));
		suite.addTest(new ProofTest("testProof","SN"));
		suite.addTest(new ProofTest("testProof","CoPo1"));
		suite.addTest(new ProofTest("testProof","CoPo2"));
		suite.addTest(new ProofTest("testProof","CoPo3"));
		suite.addTest(new ProofTest("testProof","CoPo4"));
		suite.addTest(new ProofTest("testProof","XQ1"));
		suite.addTest(new ProofTest("testProof","AEx"));
		suite.addTest(new ProofTest("testProof","AEx2"));
		suite.addTest(new ProofTest("testProof","CCo"));
		suite.addTest(new ProofTest("testProof","AnDc"));
		suite.addTest(new ProofTest("testProof","AnU"));
		suite.addTest(new ProofTest("testProof","UU"));
		suite.addTest(new ProofTest("testProof","XQ2"));
		suite.addTest(new ProofTest("testProof","NX"));

		suite.addTest(new ProofTest("testProof","D"));
		suite.addTest(new ProofTest("testProof","D1"));
		suite.addTest(new ProofTest("testProof","D2"));
		suite.addTest(new ProofTest("testProof","I"));
		suite.addTest(new ProofTest("testProof","I1"));
		suite.addTest(new ProofTest("testProof","I2"));
		suite.addTest(new ProofTest("testProof","XQ3"));
		suite.addTest(new ProofTest("testProof","DEl"));
		suite.addTest(new ProofTest("testProof","IEl"));
		suite.addTest(new ProofTest("testProof","MP"));
		suite.addTest(new ProofTest("testProof","KeRe"));
		suite.addTest(new ProofTest("testProof","ZeIm"));
		suite.addTest(new ProofTest("testProof","UD"));
		suite.addTest(new ProofTest("testProof","DCo"));
		suite.addTest(new ProofTest("testProof","DAs1"));
		suite.addTest(new ProofTest("testProof","DAs2"));

		// Base rules for predicate calculus
		suite.addTest(new ProofTest("testProof","G"));
		suite.addTest(new ProofTest("testProof","Gx"));
		suite.addTest(new ProofTest("testProof","Stx"));
		suite.addTest(new ProofTest("testProof","E"));
		suite.addTest(new ProofTest("testProof","Etx"));

		// Derived predicate rules
		suite.addTest(new ProofTest("testProof","GGx"));
		suite.addTest(new ProofTest("testProof","ExGxt"));
		suite.addTest(new ProofTest("testProof","SGxy"));
		suite.addTest(new ProofTest("testProof","AvGxy"));

		suite.addTest(new ProofTest("testProof","ESy"));
		suite.addTest(new ProofTest("testProof","ET"));

		suite.addTest(new ProofTest("testProof","ECnx"));
		suite.addTest(new ProofTest("testProof","EAnx"));
		suite.addTest(new ProofTest("testProof","GPx"));
		suite.addTest(new ProofTest("testProof","ExPxt"));
		suite.addTest(new ProofTest("testProof","SPxy"));
		suite.addTest(new ProofTest("testProof","AvPxy"));

		suite.addTest(new ProofTest("testProof","predtest"));

		suite.addTest(new ProofTest("testProof","subtest"));
		
		// Simple prop calculus
		suite.addTest(new ProofTest("testProof","oef1"));
		suite.addTest(new ProofTest("testProof","oef2"));

		// Heavy predicate stuff
		suite.addTest(new ProofTest("testProof","oef31"));
		suite.addTest(new ProofTest("testProof","oef31b"));
		suite.addTest(new ProofTest("testProof","oef371"));
		suite.addTest(new ProofTest("testProof","oef372"));
		suite.addTest(new ProofTest("testProof","oef373"));
		suite.addTest(new ProofTest("testProof","oef373b"));
		suite.addTest(new ProofTest("testProof","oef374"));

		// The "most important" substitution calculus rules
		suite.addTest(new ProofTest("testProof","SubL1"));
		suite.addTest(new ProofTest("testProof","FreeG2"));
		suite.addTest(new ProofTest("testProof","FreeNil"));
		suite.addTest(new ProofTest("testProof","FreeList"));
		suite.addTest(new ProofTest("testProof","FreeG"));
		suite.addTest(new ProofTest("testProof","SubL2"));
		suite.addTest(new ProofTest("testProof","SubL4"));
		suite.addTest(new ProofTest("testProof","SubList2"));
		suite.addTest(new ProofTest("testProof","SubG1"));
		suite.addTest(new ProofTest("testProof","VarVar"));
		suite.addTest(new ProofTest("testProof","FV1"));
		suite.addTest(new ProofTest("testProof","SubG2"));
		suite.addTest(new ProofTest("testProof","SubConst"));
		suite.addTest(new ProofTest("testProof","SubTerm"));
		suite.addTest(new ProofTest("testProof","SubList"));
		suite.addTest(new ProofTest("testProof","SubEq"));
		suite.addTest(new ProofTest("testProof","SubPred"));
		suite.addTest(new ProofTest("testProof","SubVar"));

		return suite;
	}

	/** uptoline: e.g. 0 tests only first line, 1 only first two, etc*/
	public void testProof() {
//		System.out.println("Proof "+name);
		Proof proof = (Proof)canvas.load(prfName);
		int lines = proof.getHeight();
		boolean shouldfail = false;
		boolean ignore = false;
		boolean result = true;
		for (int lineno = 0; lineno < lines; lineno++) {
			if (proof.isComment(lineno)) {
				String comment = ((StringPart)proof.elementAt(lineno,Proof.SEQUENT)).getString();
				if (comment.equals("should fail")) shouldfail = true;
				if (comment.equals("pending")) ignore = true;
				continue;
			}
			try {
				proof.vfyline(lineno,(VariableStore)canvas);
				if (shouldfail) {
					System.out.println("line "+(lineno+1)+" should fail");
					result = false;
				}
			} catch (ProofInvalidException exc) {
				if (!shouldfail && !ignore) {
					System.out.println("oops at line "+(lineno+1)+exc);
					result = false;
				}
			}
			shouldfail = false; ignore = false;
			if (lineno == uptoLine) break;
		}
		assert(result);
	}
}
